###################################################
### chunk number 1: OAIHarvester eval=FALSE
###################################################
## require("OAIHarvester")
## x <- oaih_list_records("http://www.jstatsoft.org/oai")
## JSS_papers <- oaih_transform(x[, "metadata"])
## JSS_papers <- JSS_papers[order(as.Date(unlist(JSS_papers[, "date"]))), ]
## JSS_papers <- JSS_papers[grep("Abstract:", JSS_papers[, "description"]), ]
## JSS_papers[, "description"] <- sub(".*\nAbstract:\n", "", 
##                                    unlist(JSS_papers[, "description"]))


###################################################
### chunk number 2: corpus eval=FALSE
###################################################
## data("JSS_papers", package = "corpus.JSS.papers")


###################################################
### chunk number 3: 
###################################################
options(useFancyQuotes = FALSE)
if (!require("corpus.JSS.papers")) {
require("OAIHarvester")
x <- oaih_list_records("http://www.jstatsoft.org/oai")
JSS_papers <- oaih_transform(x[, "metadata"])
JSS_papers <- JSS_papers[order(as.Date(unlist(JSS_papers[, "date"]))), ]
JSS_papers <- JSS_papers[grep("Abstract:", JSS_papers[, "description"]), ]
JSS_papers[, "description"] <- sub(".*\nAbstract:\n", "", 
                                   unlist(JSS_papers[, "description"]))
} else {
data("JSS_papers", package = "corpus.JSS.papers")
}


###################################################
### chunk number 4:  eval=FALSE
###################################################
## install.packages("corpus.JSS.papers", 
##                  repos = "http://datacube.wu.ac.at/", type = "source")
## data("JSS_papers", package = "corpus.JSS.papers")


###################################################
### chunk number 5:  eval=FALSE
###################################################
## require("OAIHarvester")
## x <- oaih_list_records("http://www.jstatsoft.org/oai")
## JSS_papers <- oaih_transform(x[, "metadata"])
## JSS_papers <- JSS_papers[order(as.Date(unlist(JSS_papers[, "date"]))), ]
## JSS_papers <- JSS_papers[grep("Abstract:", JSS_papers[, "description"]), ]
## JSS_papers[, "description"] <- sub(".*\nAbstract:\n", "", 
##                                    unlist(JSS_papers[, "description"]))


###################################################
### chunk number 6: 
###################################################
set.seed(1102)
library("topicmodels")
library("XML")
remove_HTML_markup <-
function(s) {
    doc <- htmlTreeParse(s, asText = TRUE, trim = FALSE)
    iconv(xmlValue(xmlRoot(doc)), "", "UTF-8")
}
corpus <- Corpus(VectorSource(sapply(JSS_papers[, "description"],
                                     remove_HTML_markup)))


###################################################
### chunk number 7: 
###################################################
dtm <- DocumentTermMatrix(corpus, 
   control = list(stemming = TRUE, stopwords = TRUE, minWordLength = 3,
     removeNumbers = TRUE))


###################################################
### chunk number 8: 
###################################################
dtm <- removeSparseTerms(dtm, 0.99)
dim(dtm)


###################################################
### chunk number 9: 
###################################################
jss_LDA <- LDA(dtm[1:250,], control = list(alpha = 0.1), k = 10)


###################################################
### chunk number 10:  eval=FALSE
###################################################
## jss_CTM <- CTM(dtm[1:250,], k = 10)


###################################################
### chunk number 11: 
###################################################
post <- posterior(jss_LDA, newdata = dtm[-c(1:250),])
round(post$topics[1:5,], digits = 2)


###################################################
### chunk number 12: 
###################################################
get_terms(jss_LDA, 5)


